# bdm Namespace Reference

## Detailed Description

Space of basic BDM structures.

## Classes
class | ARX
| Linear Autoregressive model with Gaussian noise. More...
class | EKFful_unQR
| Extended Kalman filter with unknown `Q` and `R`. More...
class | EKFCh_unQ
| Extended Kalman filter in Choleski form with unknown `Q`. More...
class | EKFCh_cond
| Extended Kalman filter with unknown parameters in `IM`. More...
class | KalmanFull
| Basic Kalman filter with full matrices (education purpose only)! Will be deleted soon! More...
class | Kalman
| Kalman filter with covariance matrices in square root form. More...
class | KalmanCh
| Kalman filter in square root form. More...
class | EKFfull
| Extended Kalman Filter in full matrices. More...
class | EKF
| Extended Kalman Filter. More...
class | EKFCh
| Extended Kalman Filter in Square root. More...
class | KFcondQR
| Kalman Filter with conditional diagonal matrices R and Q. More...
class | KFcondR
| Kalman Filter with conditional diagonal matrices R and Q. More...
class | PF
| Trivial particle filter with proposal density equal to parameter evolution model. More...
class | MPF
| Marginalized Particle filter. More...
class | merger
| Function for general combination of pdfs. More...
class | MixEF
| Mixture of Exponential Family Densities. More...
class | mratio
| Class representing ratio of two densities which arise e.g. by applying the Bayes rule. It represents density in the form: where . More...
class | emix
| Mixture of epdfs. More...
class | mprod
| Chain rule decomposition of epdf. More...
class | eprod
| Product of independent epdfs. For dependent pdfs, use mprod. More...
class | mmix
| Mixture of mpdfs with constant weights, all mpdfs are of equal type. More...
class | bdmroot
| Root class of BDM objects. More...
class | str
| Structure of RV (used internally), i.e. expanded RVs. More...
class | RV
| Class representing variables, most often random variables. More...
class | fnc
| Class representing function of variable represented by `rv`. More...
class | epdf
| Probability density function with numerical statistics, e.g. posterior density. More...
class | mpdf
| Conditional probability density, e.g. modeling some dependencies. More...
class | datalink
| DataLink is a connection between two data vectors Up and Down. More...
class | datalink_m2e
| data link between More...
class | datalink_m2m
class | logger
| Class for storing results (and semi-results) of an experiment. More...
class | mepdf
| Unconditional mpdf, allows using epdf in the role of mpdf. More...
class | compositepdf
| Abstract composition of pdfs, will be used for specific classes this abstract class is common to epdf and mpdf. More...
class | DS
| Abstract class for discrete-time sources of data. More...
class | BM
| Bayesian Model of a system, i.e. all uncertainty is modeled by probabilities. More...
class | BMcond
| Conditional Bayesian Filter. More...
class | MemDS
| Memory storage of off-line data column-wise. More...
class | ArxDS
| Generator of ARX data. More...
class | stateDS
class | eEF
| General conjugate exponential family posterior density. More...
class | mEF
| Exponential family model. More...
class | BMEF
| Estimator for Exponential family. More...
class | enorm
| Gaussian density with positive definite (decomposed) covariance matrix. More...
class | egiw
| Gauss-inverse-Wishart density stored in LD form. More...
class | eDirich
| Dirichlet posterior density. More...
class | multiBM
| Estimator for Multinomial density. More...
class | egamma
| Gamma posterior density. More...
class | eigamma
| Inverse-Gamma posterior density. More...
class | euni
| Uniform distributed density on a rectangular support. More...
class | mlnorm
| Normal distributed linear function with linear function of mean value;. More...
class | mlstudent
class | mgamma
| Gamma random walk. More...
class | migamma
| Inverse-Gamma random walk. More...
class | mgamma_fix
| Gamma random walk around a fixed point. More...
class | migamma_fix
| Inverse-Gamma random walk around a fixed point. More...
class | eEmp
| Weighted empirical density. More...
class | constfn
| class representing function , here `rv` is empty More...
class | linfn
| Class representing function . More...
class | diffbifn
| Class representing a differentiable function of two variables . More...
class | bilinfn
| Class representing function . More...
class | memlog
| Logging into matrices in data format in memory. More...
class | dirfilelog
| Logging into dirfile with buffer in memory. More...
class | UIFile
class | UIbuilder
| Builds computational object from a UserInfo structure. More...
class | UIexternal
class | UIinternal
## Typedefs
typedef std::map< string, int > | RVmap
typedef map< const string, const UIbuilder * > | UImap
| Internal structure mapping strings to UIBuilder objects.
## Enumerations
enum | MixEF_METHOD { EM = 0, QB = 1 }
enum | RESAMPLING_METHOD { MULTINOMIAL = 0, STRATIFIED = 1, SYSTEMATIC = 3 }
| Switch between various resampling methods.
## Functions
double | egiw_bestbelow (egiw Eg, egiw Eg0, double Egll, ivec &indeces)
| Return the best structure.
std::ostream & | operator<< (std::ostream &os, const KalmanFull &kf)
Array< string > | RV_NAMES (RV_BUFFER_STEP)
ivec | RV_SIZES (RV_BUFFER_STEP)
std::ostream & | operator<< (std::ostream &os, const RV &rv)
RV | concat (const RV &rv1, const RV &rv2)
| Concat two random variables.
template<class sq_T>
std::ostream & | operator<< (std::ostream &os, mlnorm< sq_T > &ml)
| UIREGISTER (UIexternal)
| UIREGISTER (UIinternal)
void | UI_DBG (Setting &S, const string &spc)
| [Debugging] Print values in current S to cout
template<class T>
void | UIbuild (Setting &S, T *&ret)
| Prototype of a UI builder. Return value is by the second argument since it type checking via `dynamic_cast`.
template<class T>
void | UIcall (Setting &S, void(*func)(Setting &, T), T Tmp)
| Auxiliary function allowing recursivity in S (too complex, remove?).
## Variables
const int | RV_BUFFER_STEP = 1
RVmap | RV_MAP
RV | RV0 = RV()
| Default empty RV that can be used as default argument.
ivec | RV_SIZES
Array< string > | RV_NAMES
Uniform_RNG | UniRNG
| Global Uniform_RNG.
Normal_RNG | NorRNG
| Global Normal_RNG.
Gamma_RNG | GamRNG
| Global Gamma_RNG.
UImap | __uimap__
| global map of UIbulder names to instances of UIbuilders. Created by UIREGISTER macro

## Function Documentation

double bdm::egiw_bestbelow | ( | egiw | Eg,
|  | egiw | Eg0,
|  | double | Egll,
|  | ivec & | indeces |
| ) |  |  |

Return the best structure.

Parameters:

  | Eg | a copy of GiW density that is being examined
  | Eg0 | a copy of prior GiW density before estimation
  | Egll | likelihood of the current Eg
  | indeces | current indeces

Returns:
  best likelihood in the structure below the given one

References ldmat::_D(), ldmat::_L(), bdm::egiw::_V(), ldmat::ldform(), bdm::egiw::lognc(), and ldmat::rows().

Referenced by bdm::ARX::structure_est().